=== debian/changelog ===
teeworlds (0.7.5-3) unstable; urgency=medium

  * Team Upload
  * Replace obsolete build-deps:
    * libfreetype6-dev -> libfreetype-dev
    * libgl1-mesa-dev -> libgl-dev,

  [ Debian Janitor ]
  * Apply multi-arch hints. + teeworlds-data: Add Multi-Arch: foreign.

 -- Alexandre Detiste <tchet@debian.org>  Wed, 19 Nov 2025 14:21:50 +0100

teeworlds (0.7.5-2) unstable; urgency=medium

  * Backport 91e5492d4c210f82f1ca6b43a73417fef5463368 as the hotfix
    for CVE-2021-43518 (Closes: #1009070)

 -- Moritz Muehlenhoff <jmm@debian.org>  Fri, 17 Mar 2023 11:46:31 +0100

teeworlds (0.7.5-1) unstable; urgency=medium

  * Team upload.

  [ Dylan Aïssi ]
  * Remove patches applied upstream:
    - CVE-2019-10877.patch
    - CVE-2019-10878.patch
    - CVE-2019-10879.patch
    - immintrin_FTBFS.patch
    - no-sse2-required.patch
    - recursiv_dir.patch

  [ Markus Koschany ]
  * New upstream version 0.7.5.
    - Fix CVE-2020-12066: Remote denial-of-service.
  * Build-depend on python3 instead of python. Fix python3 incompatibilities.
    (Closes: #967213, #938632)
  * Refresh the patches. Use system library libjsonparser-dev. (Closes: #958249)
  * Switch to debhelper-compat = 13.
  * Declare compliance with Debian Policy 4.5.0.

 -- Markus Koschany <apo@debian.org>  Sun, 30 Aug 2020 15:38:14 +0200
